// Bloom Effect
// Bisma Mods
precision mediump float;
uniform sampler2D Diffuse;
uniform sampler2D DifBloom;
varying mediump vec2 Out_Tex0;
uniform mediump vec4 RedGrade;
uniform mediump vec4 GreenGrade;
uniform mediump vec4 BlueGrade;

void main() {
	vec4 color2 = texture2D(Diffuse, Out_Tex0);
	float KoloR = dot(color2, RedGrade);
	float KoloG = dot(color2, GreenGrade);
	float KoloB = dot(color2, BlueGrade);
	// Box Blur
	vec4 rendr = vec4(KoloR, KoloG, KoloB, 1.0);
	float blr_limt = 0.02;
	float blr_plsd = 0.06;
	float blr_shapa = 0.15;
	for(float i = blr_plsd; i <  blr_limt;  i += blr_plsd) 
	{
		blr_shapa -= 0.12;
		if (0.0 > blr_shapa) {
			blr_shapa = 0.0;
		} else {
		rendr += texture2D(Diffuse, vec2(Out_Tex0.x + i, Out_Tex0.y)) * blr_shapa;
		rendr += texture2D(Diffuse, vec2(Out_Tex0.x - i, Out_Tex0.y)) * blr_shapa;
		}
	}
	// Brightness Extract
	float cerahh = (rendr.r + rendr.g + rendr.b) / 1.0;
	float cerahh_max = 4.00;
	if (cerahh_max > cerahh) {
		cerahh += distance(cerahh, cerahh_max);
	}
	// Render
	float Kolo2R = mix(rendr.r, KoloR, 0.20);
	float Kolo2G = mix(rendr.g, KoloG, 0.30);
	float Kolo2B = mix(rendr.b, KoloB, 0.55);
	gl_FragColor.r = mix(KoloR, Kolo2R, cerahh);
	gl_FragColor.g = mix(KoloG, Kolo2G, cerahh);
	gl_FragColor.b = mix(KoloB, Kolo2B, cerahh);
}